MENU

杭电多校2018第三场 HDU6319 Ascending Rating(单调队列)

2018 年 08 月 03 日 • 阅读: 1477 • 数据结构阅读设置

Problem A. Ascending Rating

  • Time Limit: 10000/5000 MS (Java/Others)
  • Memory Limit: 524288/524288 K (Java/Others)
  • Total Submission(s): 4334
  • Accepted Submission(s): 1438

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1 and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T($1≤T≤2000$), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD($1≤m,k≤n≤10^7,5≤p,q,r,MOD≤10^9$) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers $a_1,a_2,...,a_k(0≤a_i≤10^9)$, denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :
$$a_i=(p×a_i−1+q×i+r)modMOD$$

It is guaranteed that $\sum_{}^{}{n<=7 * 10^7}$ and $\sum_{}^{}{k<=2 * 10^6}$.

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :
$$A=\sum_{i = 1}^{n -m + 1}(maxrating_i⊕i)$$

$$B=\sum_{i = 1}^{n -m + 1}(count_i⊕i)$$

Note that '⊕' denotes binary XOR operation.

Sample Input

1
10 6 10 5 5 5 5
3 2 2 1 5 7 6 8 2 9

Sample Output

46 11

Source

2018 Multi-University Training Contest 3


链接

http://acm.hdu.edu.cn/showproblem.php?pid=6319

题意

给定一个序列 a[1..n],对于每个长度为 m 的连续子区间, 求出区间 a 的最大值以及从左往右扫描该区间时 a 的最大值的 变化次数。$1 ≤ m ≤ n ≤ 10^7$

题解

  • 按照 r 从 m 到 n 的顺序很难解决这个问题。
  • 考虑按照 r 从 n 到 m 的顺序倒着求出每个区间的答案。
  • 按照滑窗最大值的经典方法维护 a 的单调队列,那么队列 中的元素个数就是最大值的变化次数。
  • 时间复杂度 $O(n)$。

以上为官方题解,详细题解可以参考:传送门
我们把a[i]入队尾的时候,小于等于a[i]的元素都会被删掉,所以单调队列中剩余的元素刚好对应于需要交换更新的次数,但是注意得从后往前进行遍历。

代码

StatusAccepted
Time2854ms
Memory58860kB
Length1079
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
typedef long long ll;
const int maxn = 1e7 + 10;
int a[maxn], Q[maxn];

int main()
{
    int T, n, m, k, p, q, r, mod;
    scanf("%d", &T);
    while (T--)
    {
        scanf("%d%d%d%d%d%d%d", &n, &m, &k, &p, &q, &r, &mod);
        for (int i = 1; i <= n; ++i)
        {
            if (i <= k)
                scanf("%d", &a[i]);
            else
                a[i] = (1ll * p * a[i-1] + 1ll * q * i + r) % mod;
        }
        ll A = 0, B = 0;
        int head = 1, tail = 0;
        for (int i = n; i >= 1; --i)
        {
            while (head <= tail && a[Q[tail]] <= a[i]) // 维护最大值
                tail--;
            Q[++tail] = i; // 元素进入单调队列
            while (Q[head] - i >= m) // 每次到达小区间长度则头指针后移
                head++;
            if (i <= n - m + 1)
            {
                A += (ll)(a[Q[head]] ^ (1ll * i)); // 最大值
                B += (ll)((tail - head + 1) ^ (1ll * i)); // 交换次数
            }
        }
        printf("%lld %lld\n", A, B);
    }
    return 0;
}

之前好像没学过单调队列,我怎么这么菜啊。


The end.
2018-08-03 星期五
最后编辑于: 2018 年 08 月 05 日